#include <stdlib.h>
#include <stdio.h>


int mat[60][60];   // Ulazna matrica
long sum[60][60];  // Matrica zbira - pomocna
int n;


// Uchitavanje ulaznih podataka iz datoteke input.txt
// n - rang matrice, elementi matrice

int ReadInp () {

	FILE *fIn;
	int i, j;

	if ((fIn = fopen("input.txt", "rt")) == NULL) return 1;
	if (!fscanf(fIn, "%d", &n)) return 2;
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			if (!fscanf(fIn, "%d", &mat[i][j])) return 2;
	fclose(fIn);

	return 0;
}


// Racunanje pomocne matrice sum - ovo racunanje se moze vrsiti i bez
// pomocne matrice (ako optimizacija zahteva), ali je ovako preglednije

void ComputeSum () {

	int i, j;

	sum[0][0] = mat[0][0];
	for (i = 1; i < n; i++) {
		sum[i][0] = sum[i-1][0] + mat[i][0];
		sum[0][i] = sum[0][i-1] + mat[0][i];
	}

	for (i = 1; i < n; i++)
		for (j = 1; j < n; j++)
			sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + mat[i][j];
}


// Racunanje sume za date koordinate u matrici - gornje levo, donje desno

long Ssum (int x1, int y1, int x2, int y2) {

	long s;

	s = sum[x2][y2];
	if (x1 > 0) s = s - sum[x1-1][y2];
	if (y1 > 0) s = s - sum[x2][y1-1];
	if ((x1 > 0)&&(y1 > 0)) s = s + sum[x1-1][y1-1];  // Formula uklj. - isklj.

	return s;
}


// Glavni program

int main (void) {

	long sm;	// Pamcenje trenutne najbolje sume
	int xm1, ym1, xm2, ym2;	// Pamcenje trenutnih najboljih koordinata
	int i1, j1, i2, j2;	// Brojaci

	if (ReadInp ()) {
		fprintf (stderr, "\nLos ulaz !\n");
		return 1;
	}
	ComputeSum ();

	// Inicijalizacija - mora postojati bar jedno polje matrice - prvo :)
	sm = sum[0][0];
	xm1 = 0;
	ym1 = 0;
	xm2 = 0;
	ym2 = 0;

	// Ok, odredjujemo podmatricu....
	for (i1 = 0; i1 < n; i1++)
		for (j1 = 0; j1 < n; j1++)
			for (i2 = i1; i2 < n; i2++)
				for (j2 = j1; j2 < n; j2++)
					if (Ssum (i1, j1, i2, j2) > sm) {
						sm = Ssum (i1, j1, i2, j2);
						xm1 = i1;
						ym1 = j1;
						xm2 = i2;
						ym2 = j2;
					}

	// Prikaz rezultata...
	fprintf (stdout, "\nMaksimalna suma: %d\n", sm);
	fprintf (stdout, "Koordinate (gore levo - dole desno): ");
	fprintf (stdout, "%d %d %d %d\n", xm1 + 1, ym1 + 1, xm2 + 1, ym2 + 1);
	// +1 kod koordinata ubacujemo zbog korekcije - npr. da ne bi bilo 0,3
	// umesto 1,4

	return 0;	// Done !
}